/*
   This scene is (c) 1995 Han-Kwang Nienhuys

   Distributed under terms of the GPL.
*/
/*

object { mouthtube }

   / ===========(mouthpiece)
   ||
   \ ====)

 ---------------> x-direction

Reference point: center line of valve #3, at height of connection

*/

#include "tuneslide.inc"
#include "mouthpiece.inc"

#declare lfhook = composite { // hook for little finger, ref: top side of mouth tube
    intersection {
        torus { 8.5, 2 }
        plane { -x, 0 }
        plane { -x, 0 rotate y*15 }
    }
    cylinder { <0, 0, -8.5>, <-27, 0, -8.5>, 2 }
    sphere { <-27, 0, -8.5>, 2 }
    composite {
        cylinder { <0, 0, 8.5>, <-20, 0, 8.5>, 2 }
        sphere { <-20, 0, 8.5>, 2 }
        rotate y*15
    }
    scale <1,1.5,1>
    rotate -x*90
    translate <0, 8.5+7.5, 0>
    texture { nickelsilver }
}

#declare mouthtube = composite {
    
// bottom part follows:    
    
    intersection {
        torus { 7.5, 6.5 }
        plane { -z, 0 }
        plane { -x, 0 }
        translate <-7.5, 0, -7.5>
        rotate -x*3.93 // must connect perp. tot valve, entire compsite will be rot'd counterwise
    }
    
    composite {
        object { connring  translate <-7.5, 0, 0> }
        cylinder { <-7.5, 0, 0>, <-134, 0, 0>, 7 }
        object { tuneconn translate <-128.5, 0, 0> }
        object { connring translate <-134, 0, 0> }
        texture { nickelsilver }
    }
    
    
    
// tune pump follows:    
    
    object { tunepump translate (-134-tuneslidedist)*x }   // amount tune pump is slided out
    
    
    
// mouth tube follows:    
    
    composite {
        object { connring translate -134*x }
        composite {
            cylinder { -134*x, -43*x, 7 }
            torus { 5.5, 2 rotate 90*z translate -43*x }
            object { lfhook translate <-23, 0, 0> }
            texture { nickelsilver }
        }
        cylinder { -43*x, 152*x, 5.5 }
        torus { 5.5, 1.5 rotate 90*z translate 152*x }
        cylinder { 152*x, 195*x, 6 }
        object { Hexagon scale <3.5, 6.06, 6.06> translate <195-3.5, 0, 0> }
        object { mouthpiece translate <195, 0, 0> }
        translate y*67.65
    }
    
    rotate x*3.93
    translate <0, 0, 7.5+7.6>
    
}

