/*
   This scene is (c) 1995 Han-Kwang Nienhuys

   Distributed under terms of the GPL.
*/
/*

 tuning pump

 composite { tunepump }

   ======|==|== \
	       ||
   ======|==|== /
	 ^
	 |
         reference point (at center line):

 (in xy plane)

	  y-axis
	  ^
          |
	  |
 x-axis <-+------
	  |

*/

#include "tuneconn.inc"
#include "waterv.inc"

#declare tunepump = composite {
    cylinder { <88, 0, 0>, <0>, 6.5 texture {coppergrease} } // copper colored
    cylinder { <0>, <-11.5, 0, 0>, 7 texture {nickelsilver } }
    object { connringxmin translate -11.5*x }
    composite { // bend
        intersection {
            torus{52.5, 6.5 }
            plane{z, 0 rotate 16.2602*y } plane{-z, 0 rotate -17.74111*y }
            translate 25*x
        }
        
        intersection {
            torus{26.4583, 6.5 }
            plane{-z, 0 rotate y*16.2602 } plane{x, 0 }
            translate 7.2917*z
        }
        intersection {
            torus{26.4583, 6.5 }
            plane{z, 0 rotate -y*16.2602 } plane{x, 0 }
            translate -7.2917*z
        }
        rotate x*90
        translate <-13, 33.75, 0>
    }
    
    object { connringxmin translate <-11.5, 67.65, 0> }
    cylinder { <0, 67.65, 0>, <-11.5, 67.65, 0>, 7 texture {nickelsilver } }
    cylinder { <88, 67.65, 0>, <0, 67.65, 0>, 6.5 texture {coppergrease } }
    object { tuneconn translate -x*6.5 }
    object { waterv }
}

