/*
   This scene is (c) 1995 Han-Kwang Nienhuys

   Distributed under terms of the GPL.
*/
/*

First valve: valve + first pump

Reference: bottom of valve


        ===
         |
        ===
        | |
 /======| |
 ||     | |
 \======| |
        | |
        ===
*/

#define s1x = 10 // temp. can't find this dimension on datasheets now...
#define s1h = 20.59
#declare v1rad = 7

#declare thumbhook = composite {
    intersection {
        torus { 13, 3 }
        cylinder { -3*y, 3*y, 13 }
        plane { z, 0 rotate -y*8 } // sin, cos 8 deg
        plane { z, 0 }
    }
    intersection {
        union { cylinder { 13*x, <13, 0, 19>, 3 }  sphere {<13, 0, 19>, 3 } }
        plane { x, 13 }
    }
    intersection {
        union { cylinder { -13*x, <-13, 0, 15>, 3 }  sphere {<-13, 0, 15>, 3 } }
        plane { -x, 13 }
        rotate -y*8
    }
    rotate -90*x
    translate <0, 14+7, 0>
    scale <-1, 1, 1>
    intersection {
     object { las3 }
     plane { -x, 5 }
    }
    texture { nickelsilver }
}

#declare slide1 = composite {  // ref: center of valve, heigt of lower tube
    
// temp in xy-plane, ref point end of straight part    
    
    object { connring translate <2, 0, 0> } // first make the U of the slide
    cylinder { <0>, <45+s1x, 0, 0>, v1rad texture { nickelsilver } }
    object { connring translate <43+s1x, 0, 0> }
    intersection{
        torus { s1h/2, 6.5 rotate x*90 }
        plane { -x, 0 }
        translate <45+s1x, s1h/2, 0>
    }
    object { connring translate <43+s1x, s1h, 0> }
    cylinder { <45+s1x, s1h, 0>, <0, s1h, 0>, v1rad texture { nickelsilver } }
    object { connring translate <2, s1h, 0> }
    
    cylinder { <45+s1x+s1h/2, s1h/2, 0>, <45+s1x+s1h/2, s1h/2, 7.1>, 4.4 } // the little button
    sphere { <45+s1x+s1h/2, s1h/2, 7.1>, 4.4 }
    
    object { slideconnect translate 45*x }
    object { slideconnect translate <10, s1h, 0> }
    
// now rotate into real position...    
    
    rotate -29.055*x  // -arctan(10/18)
    
// and add the connections to valve    
    
    cylinder { <0>, -2.5*x, 6.5 } // lower tube
    intersection {
        torus { 7.5, 6.5 }
        plane { x, 0 }
        plane { -z, 0 }
        translate < -2.5, 0, -7.5 >
    }
    
    intersection {  // at upper tube
        torus { 7.5, 6.5 }
        plane { x, 0 }
        plane { -z, 0 }
        translate < 0, 18, -17.5 >
    }
    cylinder { <-7.5, 18, -17.5>, <-7.5, 18, -20>, 6.5 }
    
    object { thumbhook translate <16, 18, -10> }
    
// now translate to correct reference point:    
    
    translate <10, 0, 17>
    
}

#declare valve1 = composite {
    object { valve }
    object { slide1 translate <0, 35.5, 0> }
}
