/*
 bg.c -- background texturing.

  This file is based on work by George Kyriazis.

 (c) 1993, 1994, 1995 Han-Wen Nienhuys <hanwen@stack.urc.tue.nl>

this is part of Rayce, a raytracer based on "Ray" by George Kyriazis
<kyriazis@turing.cs.rpi.edu> Rayce is released under the terms of the
GNU General Public License, it has no warranty what so ever. For more
details: see the file "COPYING"
 */


#include "extern.hh"
#include "ibuf.hh"
#include "color.hh"


/* return a background gradient color */
color
Scene::bgcolor(ray * r)
{
    /* if it is above the appropriate axis just give the bgcol */
    /* if below give a gradually lighter color */
    flt         factor = bggradient * r->dir;
    color       c = *background_color;
    if (factor < -EPSILON)
        c *= (1 - 0.8 * factor);

    c.normalise();

    return c;
}
