/*
   nonvector macros
 */

inline  flt
        degtorad(const flt & deg)
{
    return M_PI * deg / 180.0;
}

inline  flt
        radtodeg(const flt & rad)
{
    return 180.0 * rad / M_PI;
}

inline flt sqr(flt a){
    return a*a;
}

template<class T>
inline int SGN(const T a)
{
    return (a < 0) ? -1 : 1;
}

inline flt ISZERO(const flt x)
{
    return (x > -EPSILON && x < EPSILON);
}

template<class T>
inline T MIN(const T a, const T b)
{
    return (a < b) ?a : b;
}

template<class T>
inline T MAX(const T a, const T b)
{
    return (a > b) ? a : b;
}

inline flt abs(const flt & b)
{
    return (b > 0) ? b : -b;
}
