/*
   ray.hh --  types, constants.

   Rayce is (c) 1993, 1996 Han-Wen Nienhuys <hanwen@stack.urc.tue.nl>
   It is based on "Ray" by George Kyriazis <kyriazis@turing.cs.rpi.edu>
 */

#ifndef RAY_HH
#define RAY_HH

#include <stdio.h>
#include <stdlib.h>
#include <math.h>


/**************** MYASSERTIONS ****************/
#ifdef DEBUG
#ifdef assert
#undef assert
#endif
#define assert(expression) \
if (!bool(expression)) {\
  fprintf(stderr, "Internal error:\n%s: %d failed assertion %s\n"\
	  "Please mail a bugreport to hanwen@stack.urc.tue.nl\n",\
	  __FILE__,__LINE__,#expression);\
  abort();\
} 

#else
#define assert(expression) 
#endif
/***********************************************/

#define EXTERN extern           /* so space can easily be allocated, see initalize.c */

#define PRIVATE static          /* local to a module */
#define PUBLIC                  /* global function */
typedef double flt;

#include "const.hh"
typedef unsigned char byte;

enum axes { X=0, Y=1, Z=2 };


// now that we have the basic declarations, include other vital info
#include "proto.hh"




#endif
